/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the MysqlBinlogDto type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MysqlBinlogDto{}

// MysqlBinlogDto struct for MysqlBinlogDto
type MysqlBinlogDto struct {
	ConnectorId   *string `json:"connectorId,omitempty"`
	TemplateId    *string `json:"templateId,omitempty"`
	Label         *string `json:"label,omitempty"`
	Strategy      *string `json:"strategy,omitempty"`
	OAuthId       *int32  `json:"o_auth_id,omitempty"`
	Table         *string `json:"table,omitempty"`
	LogStartTime  *string `json:"logStartTime,omitempty"`
	Statement     *string `json:"statement,omitempty"`
	DefaultInt    *int32  `json:"defaultInt,omitempty"`
	DefaultFloat  *int32  `json:"defaultFloat,omitempty"`
	DefaultString *string `json:"defaultString,omitempty"`
	DefaultDate   *string `json:"defaultDate,omitempty"`
}

// NewMysqlBinlogDto instantiates a new MysqlBinlogDto object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMysqlBinlogDto() *MysqlBinlogDto {
	this := MysqlBinlogDto{}
	return &this
}

// NewMysqlBinlogDtoWithDefaults instantiates a new MysqlBinlogDto object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMysqlBinlogDtoWithDefaults() *MysqlBinlogDto {
	this := MysqlBinlogDto{}
	return &this
}

// GetConnectorId returns the ConnectorId field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetConnectorId() string {
	if o == nil || IsNil(o.ConnectorId) {
		var ret string
		return ret
	}
	return *o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetConnectorIdOk() (*string, bool) {
	if o == nil || IsNil(o.ConnectorId) {
		return nil, false
	}
	return o.ConnectorId, true
}

// HasConnectorId returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasConnectorId() bool {
	if o != nil && !IsNil(o.ConnectorId) {
		return true
	}

	return false
}

// SetConnectorId gets a reference to the given string and assigns it to the ConnectorId field.
func (o *MysqlBinlogDto) SetConnectorId(v string) {
	o.ConnectorId = &v
}

// GetTemplateId returns the TemplateId field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetTemplateId() string {
	if o == nil || IsNil(o.TemplateId) {
		var ret string
		return ret
	}
	return *o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetTemplateIdOk() (*string, bool) {
	if o == nil || IsNil(o.TemplateId) {
		return nil, false
	}
	return o.TemplateId, true
}

// HasTemplateId returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasTemplateId() bool {
	if o != nil && !IsNil(o.TemplateId) {
		return true
	}

	return false
}

// SetTemplateId gets a reference to the given string and assigns it to the TemplateId field.
func (o *MysqlBinlogDto) SetTemplateId(v string) {
	o.TemplateId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *MysqlBinlogDto) SetLabel(v string) {
	o.Label = &v
}

// GetStrategy returns the Strategy field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetStrategy() string {
	if o == nil || IsNil(o.Strategy) {
		var ret string
		return ret
	}
	return *o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetStrategyOk() (*string, bool) {
	if o == nil || IsNil(o.Strategy) {
		return nil, false
	}
	return o.Strategy, true
}

// HasStrategy returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasStrategy() bool {
	if o != nil && !IsNil(o.Strategy) {
		return true
	}

	return false
}

// SetStrategy gets a reference to the given string and assigns it to the Strategy field.
func (o *MysqlBinlogDto) SetStrategy(v string) {
	o.Strategy = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *MysqlBinlogDto) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetTable returns the Table field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetTable() string {
	if o == nil || IsNil(o.Table) {
		var ret string
		return ret
	}
	return *o.Table
}

// GetTableOk returns a tuple with the Table field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetTableOk() (*string, bool) {
	if o == nil || IsNil(o.Table) {
		return nil, false
	}
	return o.Table, true
}

// HasTable returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasTable() bool {
	if o != nil && !IsNil(o.Table) {
		return true
	}

	return false
}

// SetTable gets a reference to the given string and assigns it to the Table field.
func (o *MysqlBinlogDto) SetTable(v string) {
	o.Table = &v
}

// GetLogStartTime returns the LogStartTime field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetLogStartTime() string {
	if o == nil || IsNil(o.LogStartTime) {
		var ret string
		return ret
	}
	return *o.LogStartTime
}

// GetLogStartTimeOk returns a tuple with the LogStartTime field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetLogStartTimeOk() (*string, bool) {
	if o == nil || IsNil(o.LogStartTime) {
		return nil, false
	}
	return o.LogStartTime, true
}

// HasLogStartTime returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasLogStartTime() bool {
	if o != nil && !IsNil(o.LogStartTime) {
		return true
	}

	return false
}

// SetLogStartTime gets a reference to the given string and assigns it to the LogStartTime field.
func (o *MysqlBinlogDto) SetLogStartTime(v string) {
	o.LogStartTime = &v
}

// GetStatement returns the Statement field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetStatement() string {
	if o == nil || IsNil(o.Statement) {
		var ret string
		return ret
	}
	return *o.Statement
}

// GetStatementOk returns a tuple with the Statement field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetStatementOk() (*string, bool) {
	if o == nil || IsNil(o.Statement) {
		return nil, false
	}
	return o.Statement, true
}

// HasStatement returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasStatement() bool {
	if o != nil && !IsNil(o.Statement) {
		return true
	}

	return false
}

// SetStatement gets a reference to the given string and assigns it to the Statement field.
func (o *MysqlBinlogDto) SetStatement(v string) {
	o.Statement = &v
}

// GetDefaultInt returns the DefaultInt field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetDefaultInt() int32 {
	if o == nil || IsNil(o.DefaultInt) {
		var ret int32
		return ret
	}
	return *o.DefaultInt
}

// GetDefaultIntOk returns a tuple with the DefaultInt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetDefaultIntOk() (*int32, bool) {
	if o == nil || IsNil(o.DefaultInt) {
		return nil, false
	}
	return o.DefaultInt, true
}

// HasDefaultInt returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasDefaultInt() bool {
	if o != nil && !IsNil(o.DefaultInt) {
		return true
	}

	return false
}

// SetDefaultInt gets a reference to the given int32 and assigns it to the DefaultInt field.
func (o *MysqlBinlogDto) SetDefaultInt(v int32) {
	o.DefaultInt = &v
}

// GetDefaultFloat returns the DefaultFloat field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetDefaultFloat() int32 {
	if o == nil || IsNil(o.DefaultFloat) {
		var ret int32
		return ret
	}
	return *o.DefaultFloat
}

// GetDefaultFloatOk returns a tuple with the DefaultFloat field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetDefaultFloatOk() (*int32, bool) {
	if o == nil || IsNil(o.DefaultFloat) {
		return nil, false
	}
	return o.DefaultFloat, true
}

// HasDefaultFloat returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasDefaultFloat() bool {
	if o != nil && !IsNil(o.DefaultFloat) {
		return true
	}

	return false
}

// SetDefaultFloat gets a reference to the given int32 and assigns it to the DefaultFloat field.
func (o *MysqlBinlogDto) SetDefaultFloat(v int32) {
	o.DefaultFloat = &v
}

// GetDefaultString returns the DefaultString field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetDefaultString() string {
	if o == nil || IsNil(o.DefaultString) {
		var ret string
		return ret
	}
	return *o.DefaultString
}

// GetDefaultStringOk returns a tuple with the DefaultString field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetDefaultStringOk() (*string, bool) {
	if o == nil || IsNil(o.DefaultString) {
		return nil, false
	}
	return o.DefaultString, true
}

// HasDefaultString returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasDefaultString() bool {
	if o != nil && !IsNil(o.DefaultString) {
		return true
	}

	return false
}

// SetDefaultString gets a reference to the given string and assigns it to the DefaultString field.
func (o *MysqlBinlogDto) SetDefaultString(v string) {
	o.DefaultString = &v
}

// GetDefaultDate returns the DefaultDate field value if set, zero value otherwise.
func (o *MysqlBinlogDto) GetDefaultDate() string {
	if o == nil || IsNil(o.DefaultDate) {
		var ret string
		return ret
	}
	return *o.DefaultDate
}

// GetDefaultDateOk returns a tuple with the DefaultDate field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MysqlBinlogDto) GetDefaultDateOk() (*string, bool) {
	if o == nil || IsNil(o.DefaultDate) {
		return nil, false
	}
	return o.DefaultDate, true
}

// HasDefaultDate returns a boolean if a field has been set.
func (o *MysqlBinlogDto) HasDefaultDate() bool {
	if o != nil && !IsNil(o.DefaultDate) {
		return true
	}

	return false
}

// SetDefaultDate gets a reference to the given string and assigns it to the DefaultDate field.
func (o *MysqlBinlogDto) SetDefaultDate(v string) {
	o.DefaultDate = &v
}

func (o MysqlBinlogDto) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MysqlBinlogDto) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ConnectorId) {
		toSerialize["connectorId"] = o.ConnectorId
	}
	if !IsNil(o.TemplateId) {
		toSerialize["templateId"] = o.TemplateId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Strategy) {
		toSerialize["strategy"] = o.Strategy
	}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Table) {
		toSerialize["table"] = o.Table
	}
	if !IsNil(o.LogStartTime) {
		toSerialize["logStartTime"] = o.LogStartTime
	}
	if !IsNil(o.Statement) {
		toSerialize["statement"] = o.Statement
	}
	if !IsNil(o.DefaultInt) {
		toSerialize["defaultInt"] = o.DefaultInt
	}
	if !IsNil(o.DefaultFloat) {
		toSerialize["defaultFloat"] = o.DefaultFloat
	}
	if !IsNil(o.DefaultString) {
		toSerialize["defaultString"] = o.DefaultString
	}
	if !IsNil(o.DefaultDate) {
		toSerialize["defaultDate"] = o.DefaultDate
	}
	return toSerialize, nil
}

type NullableMysqlBinlogDto struct {
	value *MysqlBinlogDto
	isSet bool
}

func (v NullableMysqlBinlogDto) Get() *MysqlBinlogDto {
	return v.value
}

func (v *NullableMysqlBinlogDto) Set(val *MysqlBinlogDto) {
	v.value = val
	v.isSet = true
}

func (v NullableMysqlBinlogDto) IsSet() bool {
	return v.isSet
}

func (v *NullableMysqlBinlogDto) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMysqlBinlogDto(val *MysqlBinlogDto) *NullableMysqlBinlogDto {
	return &NullableMysqlBinlogDto{value: val, isSet: true}
}

func (v NullableMysqlBinlogDto) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMysqlBinlogDto) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
